Skip to content
Back to top
View this page
Edit this page

# slidge.contact

Everything related to 1 on 1 chats, and other legacy users’ details.

## Classes

`LegacyContact` | This class centralizes actions in relation to a specific legacy contact.
`LegacyRoster` | Virtual roster of a gateway user that allows to represent all

## Package Contents

class slidge.contact.LegacyContact(session, stored)

  This class centralizes actions in relation to a specific legacy contact.

  You shouldn’t create instances of contacts manually, but rather rely on `LegacyRoster.by_legacy_id()` to ensure that contact instances are singletons. The `LegacyRoster` instance of a session is accessible through the `BaseSession.contacts` attribute.

  Typically, your plugin should have methods hook to the legacy events and call appropriate methods here to transmit the “legacy action” to the xmpp user. This should look like this:

  Use `carbon=True` as a keyword arg for methods to represent an action FROM the user TO the contact, typically when the user uses an official client to do an action such as sending a message or marking as message as read. This will use XEP-0363 to impersonate the XMPP user in order.

  Parameters:

    - session (slidge.core.session.BaseSession)

    - stored (slidge.db.models.Contact)

  RESOURCE: str = 'slidge'

    A full JID, including a resource part is required for chat states (and maybe other stuff) to work properly. This is the name of the resource the contacts will use.

  property client_type: slidge.util.types.ClientType

    The client type of this contact, cf https://xmpp.org/registrar/disco-categories.html#client

    Default is “pc”.

    Return type:

      slidge.util.types.ClientType

  pop_unread_xmpp_ids_up_to(horizon_xmpp_id)

    Return XMPP msg ids sent by this contact up to a given XMPP msg id.

    Legacy modules have no reason to use this, but it is used by slidge core for legacy networks that need to mark all messages as read (most XMPP clients only send a read marker for the latest message).

    This has side effects, if the horizon XMPP id is found, messages up to this horizon are cleared, to avoid sending the same read mark twice.

    Parameters:

      horizon_xmpp_id (str) – The latest message

    Returns:

      A list of XMPP ids up to horizon_xmpp_id, included

    Return type:

      list[str]

  property name: str

    Friendly name of the contact, as it should appear in the user’s roster

    Return type:

      str

  set_vcard(/, full_name = None, given = None, surname = None, birthday = None, phone = None, phones = (), note = None, url = None, email = None, country = None, locality = None, pronouns=None)

    Update xep:0292 data for this contact.

    Use this for additional metadata about this contact to be available to XMPP clients. The “note” argument is a text of arbitrary size and can be useful when no other field is a good fit.

    Parameters:

      - full_name (Optional[str])

      - given (Optional[str])

      - surname (Optional[datetime.date])

      - birthday (Optional[str])

      - phone (Iterable[str])

      - phones (Optional[str])

      - note (Optional[str])

      - url (Optional[str])

      - email (Optional[str])

      - country (Optional[str])

      - locality (Optional[str])

    Return type:

      None

  async add_to_roster(force=False)

    Add this contact to the user roster using XEP-0356

    Parameters:

      force (bool) – add even if the contact was already added successfully

    Return type:

      None

  async accept_friend_request(text=None)

    Call this to signify that this Contact has accepted to be a friend of the user.

    Parameters:

      text (Optional[str]) – Optional message from the friend to the user

    Return type:

      None

  reject_friend_request(text=None)

    Call this to signify that this Contact has refused to be a contact of the user (or that they don’t want to be friends anymore)

    Parameters:

      text (Optional[str]) – Optional message from the non-friend to the user

    Return type:

      None

  async on_friend_request(text='')

    Called when receiving a “subscribe” presence, ie, “I would like to add you to my contacts/friends”, from the user to this contact.

    In XMPP terms: “I would like to receive your presence updates”

    This is only called if self.is_friend = False. If self.is_friend = True, slidge will automatically “accept the friend request”, ie, reply with a “subscribed” presence.

    When called, a ‘friend request event’ should be sent to the legacy service, and when the contact responds, you should either call self.accept_subscription() or self.reject_subscription()

    Parameters:

      text (str)

    Return type:

      None

  async on_friend_delete(text='')

    Called when receiving an “unsubscribed” presence, ie, “I would like to remove you to my contacts/friends” or “I refuse your friend request” from the user to this contact.

    In XMPP terms: “You won’t receive my presence updates anymore (or you never have)”.

    Parameters:

      text (str)

    Return type:

      None

  async on_friend_accept()

    Called when receiving a “subscribed” presence, ie, “I accept to be your/confirm that you are my friend” from the user to this contact.

    In XMPP terms: “You will receive my presence updates”.

    Return type:

      None

  unsubscribe()

    (internal use by slidge)

    Send an “unsubscribe”, “unsubscribed”, “unavailable” presence sequence from this contact to the user, ie, “this contact has removed you from their ‘friends’”.

    Return type:

      None

  async update_info()

    Fetch information about this contact from the legacy network

    This is awaited on Contact instantiation, and should be overridden to update the nickname, avatar, vcard […] of this contact, by making “legacy API calls”.

    To take advantage of the slidge avatar cache, you can check the .avatar property to retrieve the “legacy file ID” of the cached avatar. If there is no change, you should not call `slidge.core.mixins.avatar.AvatarMixin.set_avatar()` or attempt to modify the `.avatar` property.

    Return type:

      None

  async fetch_vcard()

    It the legacy network doesn’t like that you fetch too many profiles on startup, it’s also possible to fetch it here, which will be called when XMPP clients of the user request the vcard, if it hasn’t been fetched before :return:

    Return type:

      None

  property avatar: slidge.util.types.Avatar | None

    This property can be used to set or unset the avatar.

    Unlike the awaitable :method:`.set_avatar`, it schedules the update for later execution and is not blocking

    Return type:

      slidge.util.types.Avatar | None

  async set_avatar(avatar=None, delete=False)

    Set an avatar for this entity

    Parameters:

      - avatar (slidge.util.types.Avatar | pathlib.Path | str | None) – The avatar. Should ideally come with a legacy network-wide unique ID

      - delete (bool) – If the avatar is provided as a Path, whether to delete it once used or not.

    Return type:

      None

  serialize_extra_attributes()

    If you want custom attributes of your instance to be stored persistently to the DB, here is where you have to return them as a dict to be used in deserialize_extra_attributes().

    Return type:

      dict | None

  deserialize_extra_attributes(data)

    This is where you get the dict that you passed in serialize_extra_attributes().

    ⚠ Since it is serialized as json, dictionary keys are converted to strings! Be sure to convert to other types if necessary.

    Parameters:

      data (dict)

    Return type:

      None

  invite_to(muc, reason=None, password=None, **send_kwargs)

    Send an invitation to join a group (XEP-0249) from this XMPP Entity.

    Parameters:

      - muc (slidge.group.LegacyMUC) – the muc the user is invited to

      - reason (Optional[str]) – a text explaining why the user should join this muc

      - password (Optional[str]) – maybe this will make sense later? not sure

      - send_kwargs – additional kwargs to be passed to _send() (internal use by slidge)

    Return type:

      None

  active(**kwargs)

    Send an “active” chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  composing(**kwargs)

    Send a “composing” (ie “typing notification”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  paused(**kwargs)

    Send a “paused” (ie “typing paused notification”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  inactive(**kwargs)

    Send an “inactive” (ie “contact has not interacted with the chat session interface for an intermediate period of time”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  gone(**kwargs)

    Send a “gone” (ie “contact has not interacted with the chat session interface, system, or device for a relatively long period of time”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  async send_file(attachment, legacy_msg_id=None, *, reply_to=None, when=None, thread=None, **kwargs)

    Send a single file from this XMPP Entity.

    Parameters:

      - attachment (slidge.util.types.LegacyAttachment | pathlib.Path | str) – The file to send. Ideally, a `LegacyAttachment` with a unique `legacy_file_id` attribute set, to optimise potential future reuses. It can also be: - a `pathlib.Path` instance to point to a local file, or - a `str`, representing a fetchable HTTP URL.

      - legacy_msg_id (Optional[slidge.util.types.LegacyMessageType]) – If you want to be able to transport read markers from the gateway user to the legacy network, specify this

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - when (Optional[datetime.datetime]) – when the file was sent, for a “delay” tag (XEP-0203)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      tuple[Optional[str], list[slixmpp.Message]]

  send_text(body, legacy_msg_id=None, *, when=None, reply_to=None, thread=None, hints=None, carbon=False, archive_only=False, correction=False, correction_event_id=None, link_previews=None, **send_kwargs)

    Send a text message from this XMPP Entity.

    Parameters:

      - body (str) – Content of the message

      - legacy_msg_id (Optional[slidge.util.types.LegacyMessageType]) – If you want to be able to transport read markers from the gateway user to the legacy network, specify this

      - when (Optional[datetime.datetime]) – when the message was sent, for a “delay” tag (XEP-0203)

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - hints (Optional[Iterable[slidge.util.types.ProcessingHint]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - carbon (bool) – (only used if called on a `LegacyContact`) Set this to `True` if this is actually a message sent to the `LegacyContact` by the User. Use this to synchronize outgoing history for legacy official apps.

      - correction (bool) – whether this message is a correction or not

      - correction_event_id (Optional[slidge.util.types.LegacyMessageType]) – in the case where an ID is associated with the legacy ‘correction event’, specify it here to use it on the XMPP side. If not specified, a random ID will be used.

      - link_previews (Optional[list[slidge.util.types.LinkPreview]]) – A little of sender (or server, or gateway)-generated previews of URLs linked in the body.

      - archive_only (bool) – (only in groups) Do not send this message to user, but store it in the archive. Meant to be used during `MUC.backfill()`

  correct(legacy_msg_id, new_text, *, when=None, reply_to=None, thread=None, hints=None, carbon=False, archive_only=False, correction_event_id=None, link_previews=None, **send_kwargs)

    Modify a message that was previously sent by this XMPP Entity.

    Uses last message correction (XEP-0308)

    Parameters:

      - new_text (str) – New content of the message

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – The legacy message ID of the message to correct

      - when (Optional[datetime.datetime]) – when the message was sent, for a “delay” tag (XEP-0203)

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - hints (Optional[Iterable[slidge.util.types.ProcessingHint]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - carbon (bool) – (only in 1:1) Reflect a message sent to this `Contact` by the user. Use this to synchronize outgoing history for legacy official apps.

      - archive_only (bool) – (only in groups) Do not send this message to user, but store it in the archive. Meant to be used during `MUC.backfill()`

      - correction_event_id (Optional[slidge.util.types.LegacyMessageType]) – in the case where an ID is associated with the legacy ‘correction event’, specify it here to use it on the XMPP side. If not specified, a random ID will be used.

      - link_previews (Optional[list[slidge.util.types.LinkPreview]]) – A little of sender (or server, or gateway)-generated previews of URLs linked in the body.

    Return type:

      None

  react(legacy_msg_id, emojis=(), thread=None, **kwargs)

    Send a reaction (XEP-0444) from this XMPP Entity.

    Parameters:

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – The message which the reaction refers to.

      - emojis (Iterable[str]) – An iterable of emojis used as reactions

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      None

  retract(legacy_msg_id, thread=None, **kwargs)

    Send a message retraction (XEP-0424) from this XMPP Entity.

    Parameters:

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – Legacy ID of the message to delete

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      None

  ack(legacy_msg_id, **kwargs)

    Send an “acknowledged” message marker (XEP-0333) from this XMPP Entity.

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  received(legacy_msg_id, **kwargs)

    Send a “received” message marker (XEP-0333) from this XMPP Entity. If called on a `LegacyContact`, also send a delivery receipt marker (XEP-0184).

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  displayed(legacy_msg_id, **kwargs)

    Send a “displayed” message marker (XEP-0333) from this XMPP Entity.

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  online(status=None, last_seen=None)

    Send an “online” presence from this contact to the user.

    Parameters:

      - status (Optional[str]) – Arbitrary text, details of the status, eg: “Listening to Britney Spears”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  away(status=None, last_seen=None)

    Send an “away” presence from this contact to the user.

    This is a global status, as opposed to `LegacyContact.inactive()` which concerns a specific conversation, ie a specific “chat window”

    Parameters:

      - status (Optional[str]) – Arbitrary text, details of the status, eg: “Gone to fight capitalism”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  extended_away(status=None, last_seen=None)

    Send an “extended away” presence from this contact to the user.

    This is a global status, as opposed to `LegacyContact.inactive()` which concerns a specific conversation, ie a specific “chat window”

    Parameters:

      - status (Optional[str]) – Arbitrary text, details of the status, eg: “Gone to fight capitalism”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  busy(status=None, last_seen=None)

    Send a “busy” (ie, “dnd”) presence from this contact to the user,

    Parameters:

      - status (Optional[str]) – eg: “Trying to make sense of XEP-0100”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  offline(status=None, last_seen=None)

    Send an “offline” presence from this contact to the user.

    Parameters:

      - status (Optional[str]) – eg: “Trying to make sense of XEP-0100”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  async available_emojis(legacy_msg_id=None)

    Override this to restrict the subset of reactions this recipient can handle.

    Returns:

      A set of emojis or None if any emoji is allowed

    Parameters:

      legacy_msg_id (Optional[slidge.util.types.LegacyMessageType])

    Return type:

      Optional[set[str]]

class slidge.contact.LegacyRoster(session)

  Virtual roster of a gateway user that allows to represent all of their contacts as singleton instances (if used properly and not too bugged).

  Every `BaseSession` instance will have its own `LegacyRoster` instance accessible via the `BaseSession.contacts` attribute.

  Typically, you will mostly use the `LegacyRoster.by_legacy_id()` function to retrieve a contact instance.

  You might need to override `LegacyRoster.legacy_id_to_jid_username()` and/or `LegacyRoster.jid_username_to_legacy_id()` to incorporate some custom logic if you need some characters when translation JID user parts and legacy IDs.

  Parameters:

    session (slidge.core.session.BaseSession)

  async by_legacy_id(legacy_id)

    Retrieve a contact by their legacy_id

    If the contact was not instantiated before, it will be created using `slidge.LegacyRoster.legacy_id_to_jid_username()` to infer their legacy user ID.

    Parameters:

      legacy_id (slidge.util.types.LegacyUserIdType)

    Returns:

    Return type:

      slidge.util.types.LegacyContactType

  async legacy_id_to_jid_username(legacy_id)

    Convert a legacy ID to a valid ‘user’ part of a JID

    Should be overridden for cases where the str conversion of the legacy_id is not enough, e.g., if it is case-sensitive or contains forbidden characters not covered by XEP-0106.

    Parameters:

      legacy_id (slidge.util.types.LegacyUserIdType)

    Return type:

      str

  async jid_username_to_legacy_id(jid_username)

    Convert a JID user part to a legacy ID.

    Should be overridden in case legacy IDs are not strings, or more generally for any case where the username part of a JID (unescaped with to the mapping defined by XEP-0106) is not enough to identify a contact on the legacy network.

    Default implementation is an identity operation

    Parameters:

      jid_username (str) – User part of a JID, ie “user” in “user@example.com”

    Returns:

      An identifier for the user on the legacy network.

    Return type:

      slidge.util.types.LegacyUserIdType

  async fill()

    Populate slidge’s “virtual roster”.

    This should yield contacts that are meant to be added to the user’s roster, typically by using `await self.by_legacy_id(contact_id)`. Setting the contact nicknames, avatar, etc. should be in `LegacyContact.update_info()`

    It’s not mandatory to override this method, but it is recommended way to populate “friends” of the user. Calling `await (await self.by_legacy_id(contact_id)).add_to_roster()` accomplishes the same thing, but doing it in here allows to batch DB queries and is better performance-wise.

    Return type:

      AsyncIterator[slidge.contact.contact.LegacyContact]